.include "cmp/array_structure.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "assets/assets.h.s"
.include "cpctelera.h.s"

bullet_E: DefineCmp_Entity 0, 0, 0, 0, 2, 4, 0xF0, e_ai_st_move, 1,e_type_bullet

.module sys_ai_control
	

;;Save IX
;;Input
;;	IX
sys_ai_control_init::
	ld (_ent_array_ptr_temp_standby), hl

	ld (_ent_array_ptr), hl

	ret

;;Input
;;  IX
;;  A

;;Wait for command to move to
sys_ai_standby::	
_ent_array_ptr_temp_standby = . + 2
	ld iy, #0x0000

	ld a, e_ai_aim_x(iy)
	or a
	ret z

	;;Move to player
	ld a, e_x(iy)
	ld e_ai_aim_x(ix),a
	ld a, e_y(iy)
	ld e_ai_aim_y(ix),a
	ld e_ai_st(ix), #e_ai_st_move_to


	ret
;;Move to objective x e y
sys_ai_move_to::
	ld e_vy(ix), #0
;;
;; MOVE IN X
;;
	ld a, e_ai_aim_x(ix)
	sub e_x(ix)
	jr nc, _objx_greater_or_equal
;;Same x or objx is on left side
_objx_lesser:
		ld e_vx(ix), #-1
		jr _endif_x
;; IA_x is right side of aim_X
_objx_greater_or_equal:
		jr z, _arrived_x
		ld e_vx(ix), #1
		jr _endif_x
_arrived_x:
		ld e_vx(ix), #0
_endif_x:

;;
;; MOVE IN Y
;;
	ld a, e_ai_aim_y(ix)
	sub e_y(ix)
	jr nc, _objy_greater_or_equal
;;Same x or objx is on left side
_objy_lesser:
		ld e_vy(ix), #-2
		jr _endif_y
;; IA_x is right side of aim_X
_objy_greater_or_equal:
		jr z, _arrived_y
		ld e_vy(ix), #2
		jr _endif_y
_arrived_y:
		ld e_vy(ix), #0
		ld a, e_vx(ix)
		or a
		jr nz, _endif_y
		;;X and Y zero
			ld e_ai_st(ix), #e_ai_st_stand_by
_endif_y:

	ret
sys_ai_move::
	ld e_vx(ix), #-1
	halt
	halt
	halt
	ret
sys_ai_shoot::
	ld e_ai_st(ix), #e_ai_st_stand_by
	ld iy, #bullet_E
	ld e_x(iy), #0x40

	ld hl, #bullet_E
	call man_entity_create
ret

sys_ai_bounding::
	ld e_vx(ix), #3
	ld e_vy(ix), #1
ret

sys_ai_down::
	ld e_vx(ix), #0
	ld e_vy(ix), #1

	
ret

sys_ai_control_update::

_ent_array_ptr = . + 2	
	ld ix, #0x0000



_loop:
	ld a, e_w(ix)
	cp #e_w_invalidEntity
	ret z

	ld a, e_ai_st(ix)
	cp #e_ai_st_noAI
	jr z, _no_AI_ent
_AI_ent:
	cp #e_ai_st_stand_by
	call z, sys_ai_standby
	cp #e_ai_st_move_to
	call z, sys_ai_move_to
	cp #e_ai_st_move
	call z, sys_ai_move
	cp #e_ai_st_shoot
	call z, sys_ai_shoot
	cp #e_ai_st_down
	;call z, sys_ai_down
	cp #e_ai_st_bounding
	call z, sys_ai_bounding


_no_AI_ent:


	ld de, #sizeof_e
	add ix, de

	jr _loop