;;
;; PHYSICS SYSTEM
;;

.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"
.include "collisions.h.s"
.module sys_entity_physics

screen_width = 200
max_player = 200
screen_height = 200

sys_physics_init::
	ld (_ent_array_ptr_phy), hl
	call sys_collisions_init
	ret

;;INPUT:
;; IX: Pointer to first entity to update position
;; A: Number of entities to update
;;Destroys AF, BC, DE, IX
sys_physics_update::
	_ent_array_ptr_phy = . + 2
	ld ix, #0x0000
_update_loop:
	
	ld a, e_w(ix)
	cp #e_w_invalidEntity
	ret z

	ld a, e_type(ix)
	cp #e_type_usable
	jr z, end

	call sys_check_enemy_collisions ;;Check if enemy colliders collisioned with player
	call sys_check_bullet_collisions ;;Check bullet collisions
	call sys_player_max ;;Move player
	call sys_move_rest ;;Move rest of entites
end:
	ld de, #sizeof_e
	add ix, de

	jr _update_loop

	