;;
;;RENDER SYSTEM
;;
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "cpct_functions.h.s"
.include "assets/assets.h.s"
.globl 	cpct_drawSprite_asm
.globl 	cpct_drawStringM1_asm
.globl  cpct_setDrawCharM1_asm
.globl  _start
.module sys_entity_render
string: .asciz "1. Start game";
controles: .asciz "2. Controls"
screen_start = 0xC000

_pal_main::
	.db 0, 1, 2, 3, 6, 9, 11, 12, 13, 15, 16, 18, 20, 24, 25, 26

;;Cargar inicio de pantalla
sys_eren_init::

	ld (_ent_array_ptr_eren), hl
	
	ld c, #0
	call cpct_setVideoMode_asm
	ld hl, #_pal_main
	ld de, #16
	call cpct_setPalette_asm
	cpctm_setBorder_asm HW_BLACK

	;;DRAW START
	ld    de, #0xC335
	ld    hl, #_start
	ld    b, #32
	ld    c, #32
	call cpct_drawSprite_asm

	ld h, #00
	ld l, #15
	call cpct_setDrawCharM0_asm

	ld    de, #0xC000
  	ld    b, #120               
   	ld    c, #15
	call cpct_getScreenPtr_asm
	ld iy, #string
	call cpct_drawStringM0_asm

	ld    de, #0xC000
  	ld    b, #130               
   	ld    c, #15
	call cpct_getScreenPtr_asm
	ld iy, #controles
	call cpct_drawStringM0_asm

	;;Cargar imagen fondo de pantalla play y exit
	ret
;;Update render
;;	INPUT:
;; 	IX: Pointer to first entity to render
;; 	A: Number of entities to render
;;Destroys AF, HL, BC, DE, IX
sys_eren_update::
	;;ld (_ent_array_ptr_eren), hl
	call sys_eren_render_entities

	ret
;;Renders entities	
;;INPUT::
;;	IX = Pointer to array entities
;; 	A = number of entities to render
;;	Destroys AF, HL, BC, DE, IX

sys_eren_render_entities::
	_ent_array_ptr_eren = . + 2
	ld ix, #0x0000
_update_loop:

	ld a, e_w(ix)
	cp #e_w_invalidEntity
	ret z

	ld e, e_lastVP_l(ix)
	ld d, e_lastVP_h(ix)
	xor a
	ld c, e_w(ix)
	ld b, e_h(ix)
	push bc
	call cpct_drawSolidBox_asm

	

	ld de, #screen_start
	ld c, e_x(ix)
	ld b, e_y(ix)
	call cpct_getScreenPtr_asm

	ld e_lastVP_l(ix), l
	ld e_lastVP_h(ix), h

	;;Draw entity
	ex de, hl
	
	pop bc
	
	ld a, e_type(ix)
	cp #e_type_usable
	jr z, return

	ld a, e_c(ix)	
	call cpct_drawSolidBox_asm

return:

	ld bc, #sizeof_e
	add ix, bc
	jr _update_loop

borrar_mapa::

	halt
	ld 	de, #0xC000
	ld	a, #0x00
	ld	c,#40
	ld	b,#200

	call cpct_drawSolidBox_asm

	ld de, #0xC335
	ld	a, #0x00
	ld	c,#64
	ld	b,#200
	
	call cpct_drawSolidBox_asm

ret
