.include "cpct_functions.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"
.include "collisions.h.s"
.module sys_shooting
;;
;; Shooting system
;;

bullet: DefineCmp_Entity 0, 0, 1, 0, 1, 2, e_color_bullet, e_ai_st_noAI, 1, e_type_usable

sys_shooting_init::
	ld (_array_temp), hl 
	ld (_array_temp_player), hl
	ld (_array_temp_player_1), hl 
	ld (_array_temp_enemy_1), hl 
	ld (_array_temp_enemy_2), hl 
	ret


sys_shooting_update::
_array_temp = . + 2
	ld ix, #0x0000
_sys_shooting_loop:

	ld a, e_w(ix)
	cp #e_w_invalidEntity
	ret z

	ld a, e_type(ix)
	cp #e_type_player
	jr z, player_shoot

	ld a, e_type(ix)
	cp #e_type_enemy
	call z, enemy_shoot

next_loop:
	
	ld de, #sizeof_e
	add ix, de

	jr _sys_shooting_loop
	ret

drop_timer:
	ld a, e_shootTimer(ix)
	sub #1
	ld e_shootTimer(ix), a
	jr next_loop

player_shoot:
	
	ld a, e_shootTimer(ix)
	cp #0
	jr nz, drop_timer

	ld e_shootTimer(ix), #e_shoot_player_timer
	call cpct_scanKeyboard_f_asm

	ld hl, #Key_X
	call cpct_isKeyPressed_asm
	jr z, next_loop

X_Pressed:
	
	ld d, e_x(ix)
	ld e, e_y(ix)
	push de

_array_temp_player_1 = . + 2
	ld iy, #0x0000
	;;Search if exists bullet already
_search_loop:
	ld a, e_w(iy)
	cp #e_w_invalidEntity
	jr z, create_bullet

	ld a, e_type(iy)
	cp #e_type_usable
	jr z, crear_bala_player
	
	ld bc, #sizeof_e
	add iy,bc
	
	jr _search_loop

create_bullet:
	push ix
	ld hl, #bullet
	call man_entity_create
	pop ix
_array_temp_player = . + 2
	ld iy, #0x0000

bucle_player:

	ld a, e_w(iy)
	cp #e_w_invalidEntity
	ret z

	ld a, e_type(iy)
	cp #e_type_usable
	jr z, crear_bala_player

	ld bc, #sizeof_e
	add iy,bc
	
	jr bucle_player
	
	crear_bala_player:

		pop de
		ld e_c(iy), #e_color_bullet
		ld e_h(iy), #bullet_h
		ld e_w(iy), #bullet_w
		ld	e_x(iy), d
		inc e_x(iy)
		inc e_x(iy)
		inc e_x(iy)
		ld e_vx(iy), #e_bullet_speed_player
		ld e_type(iy), #e_type_bullet
		ld 	e_y(iy), e
		ret
		

enemy_shoot:
	ld a, e_shootTimer(ix)
	cp #0
	call nz, drop_timer

	ld e_shootTimer(ix), #e_shoot_enemy_timer
	
	ld d, e_x(ix)
	ld e, e_y(ix)
	push de
_array_temp_enemy_1 = . + 2
	ld iy, #0x0000
	;;Search if exists bullet already
_search_loop_enemy:
	ld a, e_w(iy)
	cp #e_w_invalidEntity
	jr z, create_bullet_enemy

	ld a, e_type(iy)
	cp #e_type_usable
	jr z, crear_bala
	
	ld bc, #sizeof_e
	add iy,bc
	
	jr _search_loop_enemy

create_bullet_enemy::


	push ix
	ld hl, #bullet
	call man_entity_create
	pop ix
_array_temp_enemy_2 = . + 2
	ld iy, #0x0000
bucle:
	
	ld a, e_w(iy)
	cp #e_w_invalidEntity
	ret z

	ld a, e_type(iy)
	cp #e_type_usable
	jr z, crear_bala

	ld bc, #sizeof_e
	add iy,bc
	
	jr bucle
	
	crear_bala::

		pop de
		ld e_c(iy), #e_color_bullet
		ld e_h(iy), #bullet_h
		ld e_w(iy), #bullet_w
		ld	e_x(iy), d
		dec e_x(iy)
		dec e_x(iy)
		dec e_x(iy)
		ld e_vx(iy), #e_bullet_speed_enemy
		ld e_type(iy), #e_type_bullet
		ld 	e_y(iy), e
		ret
